/*
 
 Copyright (C) 2010,2011 Timo Lassmann <timolassmann@gmail.com>
 
 This file is part of delve.
 
 Delve is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 Delve is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with Delve.  If not, see <http://www.gnu.org/licenses/>.
 
 */

#include "delve.h"
#include "align.h"
//#include <xmmintrin.h>

#ifdef __GNUC__
#define _MM_ALIGN16 __attribute__ ((aligned (16)))
#endif

void align(unsigned char* q_name,unsigned char* q,unsigned char* qual, int q_len,unsigned char*t_name, unsigned char* t, int t_len ,int pos,struct hirsch_mem* hm,unsigned short int strand)
{
	//char code[] = "ACGTRYSWKMBDHVNZXQPOLJIFE";
	unsigned char a[MAX_LINE];
	unsigned char b[MAX_LINE];
	char alphabet[] = "ACGTN";
	//int ra[MAX_LINE];
	//int rb[MAX_LINE];
	int i;

	for(i = 0; i < q_len;i++){
		a[i] = alphabet[q[i]];
	}
	a[q_len] = 0;

	for(i =0;i < t_len;i++){
		b[i] = alphabet[t[i]];
	}
	b[t_len] = 0;
	
	hm->starta = 0;
	hm->startb = 0;
	
	hm->enda = q_len;
	hm->endb = t_len;
	
	hm->len_a = q_len;
	hm->len_b = t_len;
	
	hm->score = -FLT_MAX;
	
	hm->f[0].a = 0.0;
	hm->f[0].ga = -FLT_MAX;
	hm->f[0].gb = -FLT_MAX;
	hm->b[0].a = 0.0;
	hm->b[0].ga = -FLT_MAX;
	hm->b[0].gb = -FLT_MAX;
	
	for(i = 0;i < t_len+2;i++){
		hm->path[i] = -1;
	}
	//hm->path[0] = score;//p_len*5 *0.75;
	//fprintf(stderr,"a:%d	b:%d\n",p_len,t_len);
	
	//fprintf(stderr,"%f	%f	%f	%f	%f	%f\n",gpo,gpe,tgpe,subm[0][0],subm[0][1],subm[6][6]);
	hm->path = hirsch_dna_ss_dyn(a,b,hm,hm->path);//aln->s[a],aln->s[b],hm,map[c]);
	
	if(hm->path[0] != -5){
		
		print_aln(hm,q_name,q,qual,q_len,t_name, t, pos,strand);
		
		//hit = print_aln(hit,hm->path,q,text,t_size,pos,t_name,strand,hm->id_cutoff,hm->min_block_separator, hm->score,t_len,0,q->len);
	}
}

void print_aln(struct hirsch_mem* hm,unsigned char* q_name,unsigned char* q,unsigned char* qual, int q_len,unsigned char* t_name,unsigned char* t, int pos, unsigned short int strand)
//void print_aln(struct hit* hit,int* path,struct query* q,const char*t,int pos,char* t_name,unsigned short int strand,float aln_score,int t_len,int qoff,int local_len)
{
	char alphabet[] = "ACGTN";
	char q_aln[MAX_LINE];
	char t_aln[MAX_LINE];
	char cigarc[MAX_LINE];
	char cigarline[MAX_LINE];
	char mdline[MAX_LINE];
	int* path = hm->path;

	int cigarn[50];
	
	
	
	int id = 0;
	int mm,mi,md,ci;
	ci = 0;
	mm = 0;
	mi = 0;
	md = 0;

	int i = 1;
	int f = 0;
	int g = 0;
	int c = 0;
	int diff = 0;

	
	while(f < path[1]-1){
		//p_aln[c] = '-';
		//t_aln[c] =(t[f]& 0x3)+65;
		f++;
		//c++;
		//pos++;
	}
	diff = f;
	
	//qstarts[0] = 0;
	//tstarts[0] = diff;
	for(i = 1;i < q_len+1;i++){
		if(path[i] < 1){
			if(mm){
				cigarc[ci] = 'M';
				cigarn[ci] = mm;
				mm = 0;
				ci++;
			}
			if(md){
				cigarc[ci] = 'D';
				cigarn[ci] = md;
				md = 0;
				ci++;
			}
			q_aln[c] = alphabet[q[g]];
			t_aln[c] = '-';
			id--;
			mi++;
			
			//block_length++;
			c++;
			g++;
		}else{
			if(mi){
				cigarc[ci] = 'I';
				cigarn[ci] = mi;
				mi = 0;
				ci++;
			}
			if(f < path[i]-1){
				if(mm){
					cigarc[ci] = 'M';
					cigarn[ci] = mm;
					mm = 0;
					ci++;
				}

				cigarc[ci] = 'D';
				cigarn[ci] = path[i]-1 - f;
				id--;
				ci++;
			}
			while(f < path[i]-1){
				q_aln[c] = '-';
				t_aln[c] = alphabet[t[f]];
				c++;
				f++;
			}
			
			q_aln[c] = alphabet[q[g]];
			t_aln[c] = alphabet[t[f]];
			if(q_aln[c] == t_aln[c]){
				id++;
			}
			//block_length++;
			mm++;
			c++;
			g++;
			f++;
		}
	}
	if(mi){
		cigarc[ci] = 'I';
		cigarn[ci] = mi;
		mi = 0;
		ci++;
	}
	
	if(mm){
		cigarc[ci] = 'M';
		cigarn[ci] = mm;
		mm = 0;
		ci++;
	}
	if(md){
		cigarc[ci] = 'D';
		cigarn[ci] = md;
		md = 0;
		ci++;
	}
	//qstarts[num_block] = i-1-block_length;
	//tstarts[num_block] = f-block_length;
	if(g < q_len){
		cigarc[ci] = 'I';
		cigarn[ci] = q_len- g;
		ci++;
	}
	while(g < q_len){
		q_aln[c] = alphabet[q[g]];
		t_aln[c] ='-';
		c++;
		g++;
	}
	//blocks[num_block] = block_length;
	//num_block++;
	
	//while(f < t_len){
	// p_aln[c] = '-';
	// t_aln[c] = (t[f]& 0x3)+65;
	// c++;
	//fprintf(stderr,"%c	%c\n",'-',t[f]+65);
	//f++;
	//}
	
	
	
	q_aln[c] = 0;
	t_aln[c] = 0;
	
	mdline[0] = 0;
	mi = 0;
	g = 0;
	//md = 0;
	for(i = 0; i < c ;i++){
		if(q_aln[i] == t_aln[i] ){
			g++;
			mi = 0;
		}else if(t_aln[i] == '-'){
		}else{
			
			if(g){
				f = strlen(mdline);
				sprintf(mdline+f , "%d",g);
			}
			
			if(q_aln[i] == '-'){
				//md = 1;
				if (mi != 1){
					f = strlen(mdline);
					sprintf(mdline+f , "^");
				}
				f = strlen(mdline);
				sprintf(mdline+f , "%c",t_aln[i]);
				mi = 1;
			}else{
			
				f = strlen(mdline);
				sprintf(mdline+f , "%c",t_aln[i]);
				mi = 2;
			}
			g = 0;
		}
	}
	if(g){
		f = strlen(mdline);
		sprintf(mdline+f , "%d",g);
	}
	f = strlen(mdline);
	mdline[f] = 0;
	/*sprintf(mdline+f , "\n");
	if(md){*/
	//	fprintf(stderr,"%s\n%s\ncigar:%s	MD:%s	\n",q_aln,t_aln, cigarline,mdline);
	/*}*/
		
	//fprintf(stderr,"%d	%d	%c	%c\n",f,g,t_aln[0],t_aln[c-1]);
	
	
	//id = id/p_len *100.0;
	c= 0;
	cigarline[0] = 0;
	//fprintf(stderr,"%s\n%s	%d	%c	%f	%f\n",p_aln,t_aln,pos,strand,id,aln_score);
		
	for(i = 0;i < ci;i++){
		if(cigarn[i]){
			sprintf(cigarline+c,"%d%c",cigarn[i],cigarc[i]);
			c = strlen(cigarline);
			//fprintf(stderr,"%c	%d\n",cigarc[i],cigarn[i]);
		}
	}
	c = strlen(cigarline);
	cigarline[c] = 0;
	
	
	//	fprintf(stdout,"\n");
	
	//f = 0;
	//fprintf(stderr,"POS: %d	%d	diff:%d\n%d	%d\n",pos,f,diff,pos -f,t_len);
	
	
	for(i = 0;i < q_len;i++){
		q_aln[i] = alphabet[q[i]];
	}
	q_aln[q_len] = 0;
	

	sprintf(hm->pline,"%s\t%d\t%s\t%d\t%d\t%s\t%s\t%d\t%d\t%s\t%s\t",
			q_name,//1 QNAME Query NAME of the read or the read pair 
			strand,//2 FLAG bitwise FLAG (pairing, strand, mate strand, etc.) 
			t_name,//3 RNAME Reference sequence NAME 
			pos ,//4 POS 1-based leftmost POSition of clipped alignment 
			255,//5 MAPQ MAPping Quality (Phred-scaled) 
			cigarline,//6 CIGAR extended CIGAR string (operations: MIDNSHP) 
			"*",//7 MRNM Mate Reference NaMe (‘=’ if same as RNAME) 
			0,//8 MPOS 1-based leftmost Mate POSition 
			0,//9 ISIZE inferred Insert SIZE 
			q_aln,//10 SEQ query SEQuence on the same strand as the reference 
			qual//11 QUAL query QUALity (ASCII-33=Phred base quality) 
			);

	//c = strlen(hm->pline);
	//fprintf(stderr,"%s	MD:Z:%s\n",cigarline, mdline );
	c = strlen(hm->pline);
	sprintf(hm->pline+c,"AS:i:%d",(int)(hm->score / (float) q_len *100.0));
	c = strlen(hm->pline);
	sprintf(hm->pline+c,"\n");
		
		
}

int* hirsch_dna_ss_dyn(const unsigned char* seq1,const unsigned char* seq2,struct hirsch_mem* hm, int* hirsch_path)
{
	int mid = ((hm->enda - hm->starta) / 2)+ hm->starta;
	float input_states[6] = {hm->f[0].a,hm->f[0].ga,hm->f[0].gb,hm->b[0].a,hm->b[0].ga,hm->b[0].gb};
	int old_cor[5] = {hm->starta,hm->enda,hm->startb,hm->endb,mid};
	
	if(hm->starta  >= hm->enda){
		return hirsch_path;
	}
	if(hm->startb  >= hm->endb){
		return hirsch_path;
	}
	
	hm->enda = mid;
	
	//fprintf(stderr,"Forward:%d-%d	%d-%d\n",hm->starta,hm->enda,hm->startb,hm->endb);
	hm->f = foward_dyn(seq1,seq2,hm);
	
	
	hm->starta = mid;
	hm->enda = old_cor[1];
	//fprintf(stderr,"Backward:%d-%d	%d-%d\n",hm->starta,hm->enda,hm->startb,hm->endb);
	hm->b = backward_dyn(seq1,seq2,hm);
	
	
	hirsch_path = hirsch_align_two_dna_ss_vector(seq1,seq2,hm,hirsch_path,input_states,old_cor);
	return hirsch_path;
}

int* hirsch_align_two_dna_ss_vector(const unsigned char* seq1,const unsigned char* seq2,struct hirsch_mem* hm,int* hirsch_path,float input_states[],int old_cor[])
{
	struct states* f = hm->f;
 	struct states* b = hm->b;
	
	const float gpo = 1.0;
	const float gpe = 1.0;
	const float tgpe = 0.0;

	
	
	int i,c;
	int transition = -1;
	
	
	//code:
	// a -> a = 1
	// a -> ga = 2
	// a -> gb = 3
	// ga ->ga = 4
	// ga -> a = 5
	//gb->gb = 6;
	//gb->a = 7;
	
	//int max = -INFTY;
	float max = -FLT_MAX;	
	//float sub = 0.0;
	//float middle =  (hm->endb - hm->startb)/2 + hm->startb;
	
	//i = hm->startb;
	c = -1;
	for(i = hm->startb; i < hm->endb;i++){
		//sub = abs(middle -i);
		//sub /= 1000; 
		//	fprintf(stderr,"%d-%d	%f\n",hm->startb,hm->endb,sub);
		if(f[i].a+b[i].a > max){
			max = f[i].a+b[i].a;
			//		fprintf(stderr,"aligned->aligned:%d + %d = %d\n",f[i].a,b[i].a,f[i].a+b[i].a);
			transition = 1;
			c = i;
		}
		if(f[i].a+b[i].ga-gpo > max){
			max = f[i].a+b[i].ga-gpo;
			//		fprintf(stderr,"aligned->gap_a:%d + %d +%d = %d\n",f[i].a,b[i].ga,prof1[27],f[i].a+b[i].ga+prof2[27]);
			transition = 2;
			c = i;
		}
				
		if(f[i].a+b[i].gb -gpo > max){
			max = f[i].a+b[i].gb - gpo;
			//		fprintf(stderr,"aligned->gap_b:%d + %d +%d = %d\n",f[i].a,b[i].gb,prof1[27],f[i].a+b[i].gb+prof1[27]);
			transition = 3;
			c = i;
		}
		if(f[i].ga+b[i].a - gpo > max){
			max = f[i].ga+b[i].a - gpo;
			//		fprintf(stderr,"gap_a->aligned:%d + %d + %d(gpo) = %d\n",f[i].ga,b[i].a,prof2[27],f[i].ga+b[i].a+prof2[27]);
			transition = 5;
			c = i;
		}
		
		if(hm->startb == 0){
			if(f[i].gb+b[i].gb - tgpe > max){
				max = f[i].gb+b[i].gb -tgpe;
				//			fprintf(stderr,"gap_b->gap_b:%d + %d +%d(gpe) =%d \n",f[i].gb, b[i].gb, prof1[28],f[i].gb+b[i].gb+prof1[28]);
				transition = 6;
				c = i;
			}
		}else{
			if(f[i].gb+b[i].gb - gpe > max){
				max = f[i].gb+b[i].gb - gpe;
				//			fprintf(stderr,"gap_b->gap_b:%d + %d +%d(gpe) =%d \n",f[i].gb, b[i].gb, prof1[28],f[i].gb+b[i].gb+prof1[28]);
				transition = 6;
				c = i;
			}
		}
		if(f[i].gb+b[i].a - gpo > max){
			max = f[i].gb+b[i].a - gpo;
			//		fprintf(stderr,"gap_b->aligned:%d + %d + %d(gpo) = %d\n",f[i].gb,b[i].a,prof1[27],f[i].gb+b[i].a+prof1[27]);
			transition = 7;
			c = i;
		}
	}
	i = hm->endb; 
	//sub = abs(middle -i);
	//sub /= 1000000; 
	
	if(f[i].a+b[i].gb-gpo > max){
		max = f[i].a+b[i].gb - gpo;
		//		fprintf(stderr,"aligned->gap_b:%d + %d +%d = %d\n",f[i].a,b[i].gb,prof1[27],f[i].a+b[i].gb+prof1[27]);
		transition = 3;
		c = i;
	}
	
	if(hm->endb == hm->len_b){
		if(f[i].gb+b[i].gb -tgpe > max){
			max = f[i].gb+b[i].gb - tgpe;
			//			fprintf(stderr,"gap_b->gap_b:%d + %d +%d(gpe) =%d \n",f[i].gb, b[i].gb, prof1[28],f[i].gb+b[i].gb+prof1[28]);
			transition = 6;
			c = i;
		}	
	}else{
		if(f[i].gb+b[i].gb - gpe > max){
			max = f[i].gb+b[i].gb - gpe;
			//			fprintf(stderr,"gap_b->gap_b:%d + %d +%d(gpe) =%d \n",f[i].gb, b[i].gb, prof1[28],f[i].gb+b[i].gb+prof1[28]);
			transition = 6;
			c = i;
		}
	}
	
	//fprintf(stderr,"Transition:%d	at:%d	%f\n",transition,c,max);
	if(hm->score == -FLT_MAX){
		hm->score = max;
		/*if(max <= hm->path[0]){
		 hm->score = hm->path[0];
		 hirsch_path[0] = -5;
		 return hirsch_path;
		 }else{
		 hm->score = max; 
		 }*/
	}
	
	//j = hirsch_path[0];
	switch(transition){
		case 1: //a -> a = 1
			hirsch_path[old_cor[4]] = c;
			hirsch_path[old_cor[4]+1] = c+1;
			
			
			//		fprintf(stderr,"Aligning:%d-%d\n",old_cor[4],c);
			//		fprintf(stderr,"Aligning:%d-%d\n",old_cor[4]+1,c+1);
			//foward:
			hm->f[0].a = input_states[0];
			hm->f[0].ga = input_states[1];
			hm->f[0].gb = input_states[2];
			hm->b[0].a = 0.0;
			hm->b[0].ga = -FLT_MAX;
			hm->b[0].gb = -FLT_MAX;
			//		fprintf(stderr,"Using this for start:%d	%d	%d\n",hm->f[0].a,hm->f[0].ga,hm->f[0].gb);
			
			hm->starta = old_cor[0];
			hm->enda = old_cor[4]-1;
			
			hm->startb = old_cor[2];
			hm->endb = c-1;
			//fprintf(stderr,"Following first: %d  what:%d-%d	%d-%d\n",c-1,hm->starta,hm->enda,hm->startb,hm->endb);
			hirsch_path = hirsch_dna_ss_dyn(seq1,seq2,hm,hirsch_path);
			
			//backward:
			hm->starta = old_cor[4]+1;
			hm->enda = old_cor[1];
			hm->startb = c+1;
			hm->endb = old_cor[3];
			hm->f[0].a = 0.0;
			hm->f[0].ga = -FLT_MAX;
			hm->f[0].gb = -FLT_MAX;
			hm->b[0].a = input_states[3];
			hm->b[0].ga = input_states[4];
			hm->b[0].gb = input_states[5];
			
			//fprintf(stderr,"Following last: %d  what:%d-%d	%d-%d\n",c+1,hm->starta,hm->enda,hm->startb,hm->endb);
			hirsch_path = hirsch_dna_ss_dyn(seq1,seq2,hm,hirsch_path);
			break;
		case 2:// a -> ga = 2
			
			hirsch_path[old_cor[4]] = c;
			//		fprintf(stderr,"Aligning:%d-%d\n",old_cor[4],c);
			//foward:
			hm->f[0].a = input_states[0];
			hm->f[0].ga = input_states[1];
			hm->f[0].gb = input_states[2];
			hm->b[0].a = 0.0;
			hm->b[0].ga = -FLT_MAX;
			hm->b[0].gb = -FLT_MAX;
			
			
			hm->starta = old_cor[0];
			hm->enda = old_cor[4]-1;
			
			hm->startb = old_cor[2];
			hm->endb = c-1;
			//fprintf(stderr,"Following first: %d  what:%d-%d	%d-%d\n",c-1,hm->starta,hm->enda,hm->startb,hm->endb);
			hirsch_path = hirsch_dna_ss_dyn(seq1,seq2,hm,hirsch_path);
			
			
			//backward:
			hm->starta = old_cor[4];
			hm->enda = old_cor[1];
			hm->startb = c+1;
			hm->endb = old_cor[3];
			hm->f[0].a = -FLT_MAX;
			hm->f[0].ga = 0.0;
			hm->f[0].gb = -FLT_MAX;
			hm->b[0].a = input_states[3];
			hm->b[0].ga = input_states[4];
			hm->b[0].gb = input_states[5];
			
			//fprintf(stderr,"Following last: %d  what:%d-%d	%d-%d\n",c+1,hm->starta,hm->enda,hm->startb,hm->endb);
			hirsch_path = hirsch_dna_ss_dyn(seq1,seq2,hm,hirsch_path);
			break;
		case 3:// a -> gb = 3
			
			hirsch_path[old_cor[4]] = c;
			//		fprintf(stderr,"Aligning:%d-%d\n",old_cor[4],c);
			//foward:
			hm->f[0].a = input_states[0];
			hm->f[0].ga = input_states[1];
			hm->f[0].gb = input_states[2];
			hm->b[0].a = 0.0;
			hm->b[0].ga = -FLT_MAX;
			hm->b[0].gb = -FLT_MAX;
			
			hm->starta = old_cor[0];
			hm->enda = old_cor[4]-1;
			
			hm->startb = old_cor[2];
			hm->endb = c-1;
			//fprintf(stderr,"Following first: %d  what:%d-%d	%d-%d\n",c-1,hm->starta,hm->enda,hm->startb,hm->endb);
			hirsch_path = hirsch_dna_ss_dyn(seq1,seq2,hm,hirsch_path);
			//backward:
			hm->starta = old_cor[4]+1;
			hm->enda = old_cor[1];
			hm->startb = c;
			hm->endb = old_cor[3];
			hm->f[0].a = -FLT_MAX;
			hm->f[0].ga = -FLT_MAX;
			hm->f[0].gb = 0.0;
			hm->b[0].a = input_states[3];
			hm->b[0].ga = input_states[4];
			hm->b[0].gb = input_states[5];
			
			//fprintf(stderr,"Following last: %d\n",c+1);
			hirsch_path = hirsch_dna_ss_dyn(seq1,seq2,hm,hirsch_path);
			break;
		case 5://ga -> a = 5
			hirsch_path[old_cor[4]+1] = c+1;
			//		fprintf(stderr,"Aligning:%d-%d\n",old_cor[4]+1,c+1);
			
			//foward:
			hm->f[0].a = input_states[0];
			hm->f[0].ga = input_states[1];
			hm->f[0].gb = input_states[2];
			hm->b[0].a = -FLT_MAX;
			hm->b[0].ga = 0.0;
			hm->b[0].gb = -FLT_MAX;
			
			hm->starta = old_cor[0];
			hm->enda = old_cor[4];
			
			hm->startb = old_cor[2];
			hm->endb = c-1;
			//fprintf(stderr,"Following first: %d  what:%d-%d	%d-%d\n",c-1,hm->starta,hm->enda,hm->startb,hm->endb);
			hirsch_path = hirsch_dna_ss_dyn(seq1,seq2,hm,hirsch_path);
			
			//backward:
			hm->starta = old_cor[4]+1;
			hm->enda = old_cor[1];
			hm->startb = c+1;
			hm->endb = old_cor[3];
			hm->f[0].a = 0.0;
			hm->f[0].ga = -FLT_MAX;
			hm->f[0].gb = -FLT_MAX;
			hm->b[0].a = input_states[3];
			hm->b[0].ga = input_states[4];
			hm->b[0].gb = input_states[5];
			
			//fprintf(stderr,"Following last: %d\n",c+1);
			hirsch_path = hirsch_dna_ss_dyn(seq1,seq2,hm,hirsch_path);
			break;
		case 6://gb->gb = 6;
			
			//foward:
			hm->f[0].a = input_states[0];
			hm->f[0].ga = input_states[1];
			hm->f[0].gb = input_states[2];
			hm->b[0].a = -FLT_MAX;
			hm->b[0].ga = -FLT_MAX;
			hm->b[0].gb = 0.0;
			
			hm->starta = old_cor[0];
			hm->enda = old_cor[4]-1;
			hm->startb = old_cor[2];
			hm->endb = c;
			//fprintf(stderr,"Following first: %d  what:%d-%d	%d-%d\n",c-1,hm->starta,hm->enda,hm->startb,hm->endb);
			hirsch_path = hirsch_dna_ss_dyn(seq1,seq2,hm,hirsch_path);
			
			//backward:
			hm->starta = old_cor[4]+1;
			hm->enda = old_cor[1];
			hm->startb = c;
			hm->endb = old_cor[3];
			hm->f[0].a = -FLT_MAX;
			hm->f[0].ga = -FLT_MAX;
			hm->f[0].gb = 0.0;
			hm->b[0].a = input_states[3];
			hm->b[0].ga = input_states[4];
			hm->b[0].gb = input_states[5];
			
			//fprintf(stderr,"Following last: %d\n",c+1);
			hirsch_path = hirsch_dna_ss_dyn(seq1,seq2,hm,hirsch_path);
			break;
		case 7://gb->a = 7;
			hirsch_path[old_cor[4]+1] = c+1;
			//		fprintf(stderr,"Aligning:%d-%d\n",old_cor[4]+1,c+1);
			//foward:
			hm->f[0].a = input_states[0];
			hm->f[0].ga = input_states[1];
			hm->f[0].gb = input_states[2];
			hm->b[0].a = -FLT_MAX;
			hm->b[0].ga = -FLT_MAX;
			hm->b[0].gb = 0.0;
			
			hm->starta = old_cor[0];
			hm->enda = old_cor[4]-1;
			hm->startb = old_cor[2];
			hm->endb = c;
			//fprintf(stderr,"Following first: %d  what:%d-%d	%d-%d\n",c-1,hm->starta,hm->enda,hm->startb,hm->endb);
			hirsch_path = hirsch_dna_ss_dyn(seq1,seq2,hm,hirsch_path);
			
			//backward:
			hm->starta = old_cor[4]+1;
			hm->enda = old_cor[1];
			hm->startb = c+1;
			hm->endb = old_cor[3];
			hm->f[0].a = 0.0;
			hm->f[0].ga = -FLT_MAX;
			hm->f[0].gb = -FLT_MAX;
			hm->b[0].a = input_states[3];
			hm->b[0].ga = input_states[4];
			hm->b[0].gb = input_states[5];
			
			//fprintf(stderr,"Following last: %d\n",c+1);
			hirsch_path = hirsch_dna_ss_dyn(seq1,seq2,hm,hirsch_path);
			break;
	}
	return hirsch_path;
}



struct states* foward_dyn(const unsigned char* seq1,const unsigned char* seq2,struct hirsch_mem* hm)
{
	struct states* s = hm->f;
	//float *subp = 0;
	
	const float gpo = 1.0;
	const float gpe = 1.0;
	const float tgpe = 0.0;

	const int starta = hm->starta;
	const int enda = hm->enda;
	const int startb = hm->startb;
	const int endb = hm->endb;
	
	register float pa = 0;
	register float pga = 0;
	//register float pgb = 0;
	//register float plga = 0;
	register float ca = 0;
	register float xa = 0; 
	register float xga = 0;
	register int i = 0;
	register int j = 0;
	
	s[startb].a = s[0].a;
	s[startb].ga = s[0].ga;
	s[startb].gb = s[0].gb;
	
	//fprintf(stderr,"%0.1f	",s[startb].a);
	if(startb == 0){
		for (j = startb+1; j < endb;j++){
			s[j].a = -FLT_MAX;
			s[j].ga = MAX(s[j-1].ga,s[j-1].a)-tgpe;
			s[j].gb = -FLT_MAX;
			//		fprintf(stderr,"%0.1f	",s[j].a);
		}		
	}else{
		for (j = startb+1; j < endb;j++){
			s[j].a = -FLT_MAX;
			s[j].ga = MAX(s[j-1].ga - gpe,s[j-1].a-gpo);
			s[j].gb = -FLT_MAX;
		}
	}
	s[endb].a = -FLT_MAX;
	s[endb].ga = -FLT_MAX;
	s[endb].gb = -FLT_MAX;
	//fprintf(stderr,"%0.1f\n",s[endb].a);
	seq2--;
	
	for (i = starta;i < enda;i++){
		//subp = subm[seq1[i]];
		
		pa = s[startb].a;
		//pga = s[startb].ga;
		//plga = s[startb].lga;
		
		//pga = MAX(,s[startb].lga-lgpo);
		pga = MAX(s[startb].gb,s[startb].ga) -gpo;
		//pgb = s[startb].gb;
		
		s[startb].a = -FLT_MAX;
		s[startb].ga = -FLT_MAX;
		xa = s[startb].a;
		xga = s[startb].ga;
		//fprintf(stderr,"%0.1f	",s[startb].a);
		
		if(startb == 0){
			s[startb].gb = MAX(s[startb].gb,pa) - tgpe;
		}else{
			s[startb].gb = MAX(s[startb].gb - gpe,pa - gpo);
		}
		
		for (j = startb+1; j < endb;j++){
			ca = s[j].a;
			
			//pa = MAX4(pa,pga-gpo,plga-lgpo,pgb-gpo);
			pa = MAX(pa,pga);//,pgb-gpo);
			pa += (seq1[i] == seq2[j]) ? 1.0 : -1.0;//subp[seq2[j]];
			//fprintf(stderr,"%c	%c	%f\n",(char)((seq1[i]&0x3) + 65),(char)(seq2[j]+65),subp[seq2[j]]);
			
			s[j].a = pa;
			
			//pga = s[j].ga;
			//plga = s[j].lga;
			
			pga = MAX(s[j].gb,s[j].ga) - gpo;
			//pgb = s[j].gb;
			
			s[j].ga = MAX(xga-gpe,xa-gpo);
			//s[j].lga = MAX(xlga,xa-lgpo);
			s[j].gb = MAX(s[j].gb -gpe ,ca-gpo);
			
			pa = ca;
			
			xa = s[j].a;
			xga = s[j].ga;
			//xlga = s[j].lga;
			//fprintf(stderr,"%0.1f (%d,%d)	",s[j].a,seq1[i],seq2[j]);
			
		}
		ca = s[j].a;
		
		//pa = MAX4(pa,pga-gpo,plga-lgpo,pgb-gpo);
		
		pa = MAX(pa,pga);//,pgb-gpo);
		pa += (seq1[i] == seq2[j]) ? 1.0 : -1.0;
		
		s[j].a = pa;
		
		s[j].ga = -FLT_MAX;//MAX(s[j-1].ga-gpe,s[j-1].a-gpo);
		//s[j].lga = -FLT_MAX;
		if (endb != hm->len_b){
			s[j].gb = MAX(s[j].gb-gpe ,ca-gpo);
		}else{
			s[j].gb = MAX(s[j].gb,ca)-tgpe;
		}
		//fprintf(stderr,"%0.1f\n",s[endb].a);
	}
	return s;
}

struct states* backward_dyn(const unsigned char* seq1,const unsigned char* seq2,struct hirsch_mem* hm)
{
	
	struct states* s = hm->b;
	//float *subp = 0;
	const float gpo = 1.0;
	const float gpe = 1.0;
	const float tgpe = 0.0;
	
	const int starta = hm->starta;
	const int enda = hm->enda;
	const int startb = hm->startb;
	const int endb = hm->endb;
	register float pa = 0;
	register float pga = 0;
	//register float plga = 0;
	//register float pgb = 0;
	
	
	register float ca = 0;
	register float xa = 0; 
	register float xga = 0; 
	register int i = 0;
	register int j = 0;
	
	s[endb].a = s[0].a ;
	s[endb].ga = s[0].ga;
	s[endb].gb = s[0].gb;
	
	//init of first row;
	
	//j = endb-startb;
	if(endb == hm->len_b){
		for(j = endb-1;j > startb;j--){
			s[j].a = -FLT_MAX;
			s[j].ga = MAX(s[j+1].ga,s[j+1].a)-tgpe;
			s[j].gb = -FLT_MAX;
		}
	}else{
		for(j = endb-1;j > startb;j--){
			s[j].a = -FLT_MAX;
			s[j].ga = MAX(s[j+1].ga-gpe,s[j+1].a-gpo);		
			s[j].gb = -FLT_MAX;
		}
	}
	
	
	s[startb].a = -FLT_MAX;
	s[startb].ga = -FLT_MAX;
	s[startb].gb = -FLT_MAX;
	
	i = enda-starta;
	seq1+= starta;
	while(i--){
		//subp = subm[seq1[i]];
		pa = s[endb].a;
		
		
		//pga = s[endb].ga;
		//plga = s[endb].lga;
		
		pga = MAX(s[endb].gb,s[endb].ga)-gpo;
		//pgb = s[endb].gb;
		
		s[endb].a = -FLT_MAX;
		s[endb].ga = -FLT_MAX;
		
		xa = s[endb].a;
		xga = s[endb].ga;
		
		if(endb == hm->len_b){
			s[endb].gb = MAX(s[endb].gb,pa)-tgpe;
		}else{
			s[endb].gb = MAX(s[endb].gb-gpe,pa-gpo);
		}
		
		for(j = endb-1;j > startb;j--){
			
			ca = s[j].a;
			//pa = MAX4(pa,pga - gpo,plga-lgpo,pgb-gpo);
			pa = MAX(pa,pga);//,pgb-gpo);
			
			pa +=  (seq1[i] == seq2[j]) ? 1.0 : -1.0; //subp[seq2[j]];
			//fprintf(stderr,"%f	%c	%c\n",subp[seq2[j]],seq1[i]+65,seq2[j]+65);
			s[j].a = pa;
			
			//pga = s[j].ga;
			//plga = s[j].lga;

			pga = MAX(s[j].gb,s[j].ga )-gpo;
			//pgb = s[j].gb;
			//s[j].ga = MAX(s[j+1].ga-gpe,s[j+1].a-gpo);
			
			s[j].ga = MAX(xga-gpe,xa-gpo);
			s[j].gb = MAX(s[j].gb-gpe,ca-gpo);
			
			
			pa = ca;
			
			xa = s[j].a;
			xga = s[j].ga;
		}
		ca = s[j].a;
		
		//pa = MAX4(pa,pga - gpo,plga-lgpo,pgb-gpo);
		pa = MAX(pa,pga);//,pgb-gpo);
		
		pa += (seq1[i] == seq2[j]) ? 1.0 : -1.0;
		
		s[j].a = pa;
		
		s[j].ga = -FLT_MAX;//MAX(s[j+1].ga-gpe,s[j+1].a-gpo);
		
		if(startb){
			s[j].gb = MAX(s[j].gb-gpe,ca-gpo);
		}else{
			s[j].gb = MAX(s[j].gb,ca)-tgpe;
		}
	}		
	return s;
}



struct hirsch_mem* hirsch_mem_alloc(struct hirsch_mem* hm,int x)
{
	
	// a=((typeof(a))(((int)(((void *)malloc(c+15))+15))&-16)). 
	hm = (struct hirsch_mem *) malloc(sizeof(struct hirsch_mem));
	hm->starta = 0;
	hm->startb = 0;
	hm->enda = 0;
	hm->endb = 0;
	hm->size = x;
	hm->len_a = 0;
	hm->len_b = 0;
	hm->score = 0;
	
	hm->pline = malloc(sizeof(char)*MAX_LINE);
	hm->f = malloc(sizeof(struct states)* (x+1));
	hm->b = malloc(sizeof(struct states)* (x+1));
	hm->path = malloc(sizeof(int)*(x+2));
	//hm->subm = init_dyn(hm->subm);
	return hm;
}

struct hirsch_mem* hirsch_mem_realloc(struct hirsch_mem* hm,int x)
{
	hm->starta = 0;
	hm->startb = 0;
	hm->enda = 0;
	hm->endb = 0;
	hm->len_a = 0;
	hm->len_b = 0;
	hm->size = x;
	hm->f = realloc(hm->f,sizeof(struct states)* (x+1));
	hm->b = realloc(hm->b,sizeof(struct states)* (x+1));
	hm->path = realloc(hm->path,sizeof(int)*(x+2));
	return hm;
}

void hirsch_mem_free(struct hirsch_mem* hm)
{
	free(hm->pline);
	free(hm->f);
	free(hm->b);
	free(hm->path);
	free(hm);
}


