/*
 *
 *  Heavily adopted from the HMMER code
 *
 */

#include "mathsupport.h"

float logsum_lookup[LOGSUM_SIZE];

void init_logsum()
{
	int i;
	for(i = 0; i < LOGSUM_SIZE;i++){
		//logsum_lookup[i] = SCALE * 1.442695041f * (log(1.0f + exp(0.693147181f*(float)-i/SCALE)));
		logsum_lookup[i] =  log(1. + exp((double) -i / SCALE));
	}
}

float logsum(float a,float b)
{
	
	const float max = HMMER3_MAX(a, b);
	const float min = HMMER3_MIN(a, b);
	return (min == -SCALEINFTY || (max-min) >= 15.7f) ? max : max + logsum_lookup[(int)((max-min)*SCALE)];
}

float logsum_print(float a,float b)
{
	int diff;
	diff =  a -b;
		
	fprintf(stderr,"DIFF:%d	(%f -	%f) %d\n",diff,a,b,LOGSUM_SIZE);
	if(diff >= LOGSUM_SIZE){
		return a;
	}else if( diff <= -LOGSUM_SIZE){
		return b;
	}else if(diff > 0){
		fprintf(stderr,"a+sum DIFF:%0.9f  (%f)\n", logsum_lookup[(int)diff] ,sreLOG2(1. + sreEXP2(b-a) ));
		return a + logsum_lookup[diff];
	}else{
		fprintf(stderr,"b+ sum DIFF:%0.9f (%f)\n", logsum_lookup[-(int)diff],sreLOG2(1. + sreEXP2(a-b) ));
		return b + logsum_lookup[-diff];
	}
}


float prob2scaledprob(float p)
{
	if(p == 0.0){
		return -SCALEINFTY;
	}else{
		return  log(p);
		//return SCALE * sreLOG2(p);
	}
}


float scaledprob2prob(float p)
{
	if(p == -SCALEINFTY){
		return 0.0;
	}else{
		return exp(p);
		//return sreEXP2(p / SCALE);
	}
}

